"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MysqlService = void 0;
const common_1 = require("@nestjs/common");
const mysql = require("mysql2/promise");
const common_constants_1 = require("./common.constants");
let MysqlService = class MysqlService {
    constructor(options) {
        this.options = options;
        this.POOL = mysql.createPool(options);
    }
    async getConnection() {
        return await this.POOL.getConnection(async (conn) => conn);
    }
    async query(data) {
        const { sql, value } = data;
        const conn = data.conn || this.POOL;
        const [result] = await conn.query(sql, value);
        return result;
    }
    async execute(data) {
        const { sql, value } = data;
        const conn = data.conn || this.POOL;
        const [result] = await conn.execute(sql, value);
        return result;
    }
    async transaction(conn) {
        return await conn.beginTransaction();
    }
    async commit(conn) {
        return await conn.commit();
    }
    async rollback(conn) {
        return await conn.rollback();
    }
    async release(conn) {
        conn.release();
    }
};
MysqlService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(common_constants_1.CONFIG_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], MysqlService);
exports.MysqlService = MysqlService;
//# sourceMappingURL=mysql.service.js.map